using System;
using System.IO;
using PM9;

class HelloClass {
	static void Main() {
		string data_file = "sample_utf8.txt";

		int MaxLines = 50;
		string[] Lines = new string[50];
		int LastLine, Counter;

		FastPDFGen pdfgen = new FastPDFGen("DEMO.FASTNET::2024/11/28::391EB2ACC1FB89CED0FECB6CA7D5B966");
		pdfgen.compressField();
		pdfgen.start("pdfgensample4_r.pdf");
		
		LastLine = 0;
		Counter = 1;
		using(StreamReader r = new StreamReader(data_file)) {
			string line;
			while((line = r.ReadLine()) != null) {
				Lines[LastLine] = line;
				LastLine++;
				if (LastLine >= MaxLines) {
					PrintPage(pdfgen, Lines, LastLine, Counter);
					LastLine = 0;
				}
			}
		}

		if (LastLine > 0) {
			PrintPage(pdfgen, Lines, LastLine, Counter);
		}

		pdfgen.finish();
		pdfgen = null;
	}


	public static void PrintPage(FastPDFGen pdfgen, String[] Lines, int LastLine, int Counter) {
				int DispLineNo, LineNo;

		int DrawPointX = 85;
		int DrawPointY = 135;
		int BoxWidth = 310;
		int LineHeight = 12;
		int HeaderHeight = 23;
		int DrawPointItem2 = 67;
		int DrawPointItem3 = 217;

		pdfgen.startPage("pdfgensample4.pdf.tpl");

		pdfgen.drawBox(DrawPointX, DrawPointY, BoxWidth, (HeaderHeight + LineHeight * LastLine + 1), 0.6f, 1, 0, 0, 0);

		pdfgen.drawLine(DrawPointX, (DrawPointY + HeaderHeight - 4), BoxWidth, 0, 0.3f, 1, 0, 0, 0);
		pdfgen.drawLine(DrawPointX, (DrawPointY + HeaderHeight - 2), BoxWidth, 0, 0.3f, 1, 0, 0, 0);

		for (LineNo = 1; LineNo < LastLine; LineNo++) {
			pdfgen.drawLine(DrawPointX, (DrawPointY + HeaderHeight + LineHeight * LineNo), BoxWidth, 0, 0.2f, 1, 0, 0, 0);
		}

		pdfgen.drawLine((DrawPointX + DrawPointItem2), DrawPointY, 0, (HeaderHeight + LineHeight * LastLine + 1), 0.2f, 1, 0, 0, 0);
		pdfgen.drawLine((DrawPointX + DrawPointItem3), DrawPointY, 0, (HeaderHeight + LineHeight * LastLine + 1), 0.2f, 1, 0, 0, 0);

		pdfgen.makeArrayPageField("item1", LastLine, LineHeight);
		pdfgen.makeArrayPageField("item2", LastLine, LineHeight);
		pdfgen.makeArrayPageField("item3", LastLine, LineHeight);

		pdfgen.setPageFieldData("date", "2013/03/21");
		pdfgen.setPageFieldData("title1", "No.");
		pdfgen.setPageFieldData("title2", "");
		pdfgen.setPageFieldData("title3", "t");

		for (LineNo = 0; LineNo < LastLine; LineNo++) {
			DispLineNo = LineNo + 1;
			string[] Items = Lines[LineNo].Split(',');

			pdfgen.setPageFieldData("item1__" + DispLineNo, Convert.ToString(Counter));
			pdfgen.setPageFieldData("item2__" + DispLineNo, Items[0]);
			pdfgen.setPageFieldData("item3__" + DispLineNo, Items[1]);
			Counter++;
		}

		pdfgen.endPage();
	}
}
